ConfigDialog = class( Turbine.UI.Lotro.Window );

configurationDialogInstance = nil;
function BuildConfigDialog()
	if(configurationDialogInstance==nil) then
		configurationDialogInstance = ConfigDialog();
	end
	return configurationDialogInstance;
end

function ConfigDialog:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	local width, height = Turbine.UI.Display.GetSize();		
	self:SetSize( 350, 215 );
	self:SetPosition( width/2-self:GetWidth()/2, height/3-self:GetHeight()/2 );
	self:SetText( "Configuration" );	
	self:BuildBloc(self);
	
	return optionsPanel;
end

function ConfigDialog:BuildBloc(parent)
	local optDiversTitleLabel = Turbine.UI.Label();
	optDiversTitleLabel:SetParent( parent );
	optDiversTitleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);	
	optDiversTitleLabel:SetText(_("LAUNCHERTITLE"));
	optDiversTitleLabel:SetPosition( 15, 40 );
	optDiversTitleLabel:SetSize(300, 20);
	optDiversTitleLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	optDiversTitleLabel:SetMouseVisible( false );
	
	-- local defaultButton=Turbine.UI.Lotro.Button();
	-- defaultButton:SetParent(parent);
	-- defaultButton:SetPosition( 15, 40 );
	-- defaultButton:SetSize(250,20);
	-- defaultButton:SetText(_("CONFDEFAULT"));
	-- defaultButton:SetParent(optionsPanel);
	
	local canMoveQuicklauncherCheckbox = Turbine.UI.Lotro.CheckBox();
	canMoveQuicklauncherCheckbox:SetParent(parent);
	canMoveQuicklauncherCheckbox:SetMultiline( false );
	canMoveQuicklauncherCheckbox:SetPosition( 15, 65 );
	canMoveQuicklauncherCheckbox:SetSize( 360, 20 );
	canMoveQuicklauncherCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	canMoveQuicklauncherCheckbox:SetText( _("CONFMOVE") );
	canMoveQuicklauncherCheckbox:SetChecked(settings.canMoveQuickLauncher);
	canMoveQuicklauncherCheckbox:SetMouseVisible( false );
	canMoveQuicklauncherCheckbox.CheckedChanged = function(sender, args)
		settings.canMoveQuickLauncher = canMoveQuicklauncherCheckbox:IsChecked();
		Savesettings();
	end
	local useQuickLauncherCheckbox = Turbine.UI.Lotro.CheckBox();
	useQuickLauncherCheckbox:SetParent(parent);
	useQuickLauncherCheckbox:SetMultiline( false );
	useQuickLauncherCheckbox:SetPosition( 15, 85 );
	useQuickLauncherCheckbox:SetSize( 360, 20 );
	useQuickLauncherCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	useQuickLauncherCheckbox:SetText( _("CONFSHOWLAUNCHER") );
	useQuickLauncherCheckbox:SetChecked(settings.useQuickLauncher);
	useQuickLauncherCheckbox:SetMouseVisible( false );
	useQuickLauncherCheckbox.CheckedChanged = function(sender, args)
		settings.useQuickLauncher = useQuickLauncherCheckbox:IsChecked();
		Savesettings();
	end			
	local autoShowOnLaunchCheckbox = Turbine.UI.Lotro.CheckBox();
	autoShowOnLaunchCheckbox:SetParent(parent);
	autoShowOnLaunchCheckbox:SetMultiline( false );
	autoShowOnLaunchCheckbox:SetPosition( 15, 105 );
	autoShowOnLaunchCheckbox:SetSize( 360, 20 );
	autoShowOnLaunchCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	autoShowOnLaunchCheckbox:SetText( _("CONFAUTOLAUNCH") );
	autoShowOnLaunchCheckbox:SetChecked(settings.autoShowOnLaunch);
	autoShowOnLaunchCheckbox:SetMouseVisible( false );
	autoShowOnLaunchCheckbox.CheckedChanged = function(sender, args)
		settings.autoShowOnLaunch = autoShowOnLaunchCheckbox:IsChecked();
		Savesettings();
	end	
		
	local opacityLabel = Turbine.UI.Label();
	opacityLabel:SetParent( parent );
	opacityLabel:SetMultiline( false );
	opacityLabel:SetPosition( 15, 140 );
	opacityLabel:SetSize( 360, 20 );
	opacityLabel:SetText( _("CONFOPACITY") );
	local opacityTextBox = Turbine.UI.Label();
	opacityTextBox:SetParent( parent );
	opacityTextBox:SetMultiline( false );
	opacityTextBox:SetPosition( 170, 140 );
	opacityTextBox:SetSize( 250, 20 );
	opacityTextBox:SetEnabled( false );
	--opacityTextBox:SetFont( Turbine.UI.Lotro.Font.Verdana14 );
	opacityTextBox:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	opacityTextBox.customValue = tonumber(settings.defaultOpacity);
	opacityTextBox:SetText( settings.defaultOpacity.." %" );
	local opacityMinusButton=Turbine.UI.Lotro.Button();
	opacityMinusButton:SetParent(parent);
	opacityMinusButton:SetPosition( 210, 135 );
	opacityMinusButton:SetSize(16,16);
	opacityMinusButton:SetText("-");
	local opacityAddButton=Turbine.UI.Lotro.Button();
	opacityAddButton:SetParent(parent);
	opacityAddButton:SetPosition( 250, 135 );
	opacityAddButton:SetSize(16,16);
	opacityAddButton:SetText("+");	
	opacityMinusButton:SetEnabled(opacityTextBox.customValue>20);
	opacityAddButton:SetEnabled(opacityTextBox.customValue<100);	
	opacityMinusButton.MouseClick=function(sender,args)
		UpdateOpacity(opacityTextBox.customValue-10);
	end
	opacityAddButton.MouseClick=function(sender,args)
		UpdateOpacity(opacityTextBox.customValue+10);

	end
	
	function UpdateOpacity(value)		
		if(value==nil) then
			return;
		elseif(value>100) then
			opacityTextBox.customValue = 100;
		elseif(value<20) then
			opacityTextBox.customValue = 20;
		else
			opacityTextBox.customValue = value
		end
		opacityTextBox:SetText( opacityTextBox.customValue.." %" );	
		settings.defaultOpacity = string.match(opacityTextBox.customValue, '%d+');			
		opacityMinusButton:SetEnabled(opacityTextBox.customValue>20);
		opacityAddButton:SetEnabled(opacityTextBox.customValue<100);
		Savesettings();
	end
	
	-- defaultButton.MouseClick=function(sender,args)
		-- Reinitsettings();
		-- UpdateOpacity(60);
		-- autoShowOnLaunchCheckbox:SetChecked(settings.autoShowOnLaunch);
		-- useQuickLauncherCheckbox:SetChecked(settings.useQuickLauncher);
		-- canMoveQuicklauncherCheckbox:SetChecked(settings.canMoveQuickLauncher);
		-- animateQuickLaunchCheckbox:SetChecked(settings.animateQuickLauncher);
	-- end	

	local updateAtLaunchAndUnloadCheckbox = Turbine.UI.Lotro.CheckBox();
	updateAtLaunchAndUnloadCheckbox:SetParent(parent);
	updateAtLaunchAndUnloadCheckbox:SetMultiline( false );
	updateAtLaunchAndUnloadCheckbox:SetPosition( 15, 155 );
	updateAtLaunchAndUnloadCheckbox:SetSize( 360, 20 );
	updateAtLaunchAndUnloadCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	updateAtLaunchAndUnloadCheckbox:SetText( _("CONFUPDATE") );
	updateAtLaunchAndUnloadCheckbox:SetChecked(settings.updateAtLaunchAndUnload);
	updateAtLaunchAndUnloadCheckbox:SetMouseVisible( false );
	updateAtLaunchAndUnloadCheckbox.CheckedChanged = function(sender, args)
		settings.updateAtLaunchAndUnload = updateAtLaunchAndUnloadCheckbox:IsChecked();
		Savesettings();
	end	
	local updateAtLaunchCheckbox = Turbine.UI.Lotro.CheckBox();
	updateAtLaunchCheckbox:SetParent(parent);
	updateAtLaunchCheckbox:SetMultiline( false );
	updateAtLaunchCheckbox:SetPosition( 15, 175 );
	updateAtLaunchCheckbox:SetSize( 360, 20 );
	updateAtLaunchCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	updateAtLaunchCheckbox:SetText( _("CONFUPDATE2") );
	updateAtLaunchCheckbox:SetChecked(settings.updateAtLaunch);
	updateAtLaunchCheckbox:SetMouseVisible( false );
	updateAtLaunchCheckbox.CheckedChanged = function(sender, args)
		settings.updateAtLaunch = updateAtLaunchCheckbox:IsChecked();
		Savesettings();
	end			
end