import "WalmPlugins.BandOfFarmers.GenericTooltip";

CraftGlobalNode = class( Turbine.UI.TreeNode );

function CraftGlobalNode:Constructor(players)
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 35 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self:SetBackground("WalmPlugins/BandOfFarmers/background_blue.tga");
	
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetSize( 20, 20 );
	self.classLabel:SetPosition( 9, 7 );
	self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga");
	self.classLabel:SetPosition( 6, 5 );
	self.classLabel:SetSize( 26, 24 );
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.classLabel:SetMouseVisible( false );

	self.leftbox = Turbine.UI.Label();
	self.leftbox:SetParent( self );
	self.leftbox:SetPosition(0, 0);
	self.leftbox:SetSize(37, 35);
	self.leftbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.leftbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_l.tga");	
	self.rightbox = Turbine.UI.Label();
	self.rightbox:SetParent( self );
	self.rightbox:SetSize(6, 35);
	self.rightbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.rightbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_r.tga");
	self.middlebox = Turbine.UI.Label();
	self.middlebox:SetParent( self );
	self.middlebox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.middlebox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box_m.tga");
	self.middlebox:SetPosition(37, 0);

	local iconeTop = 5;
	self.cookSlotLabel = Turbine.UI.Control();
	self.cookLabel = Turbine.UI.Control();
	self:SetIconeParameters(self.cookSlotLabel, self.cookLabel, 43, iconeTop, "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_cook.tga", _("COOKER"));
	self:CreateBestPlayerTooptipByCraft(players, self.cookSlotLabel, _("COOKER"));
	
	self.farmerSlotLabel = Turbine.UI.Control();
	self.farmerLabel = Turbine.UI.Control();
	self:SetIconeParameters(self.farmerSlotLabel, self.farmerLabel, 69, iconeTop, "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_farmer.tga", _("FARMER"));
	self:CreateBestPlayerTooptipByCraft(players, self.farmerSlotLabel, _("FARMER"));

	self.foresterSlotLabel = Turbine.UI.Control();	
	self.foresterLabel = Turbine.UI.Control();
	self:SetIconeParameters(self.foresterSlotLabel, self.foresterLabel, 95, iconeTop, "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_forester.tga", _("FORESTER"));
	self:CreateBestPlayerTooptipByCraft(players, self.foresterSlotLabel, _("FORESTER"));
	
	self.jewellerSlotLabel = Turbine.UI.Control();
	self.jewellerLabel = Turbine.UI.Control();
	self:SetIconeParameters(self.jewellerSlotLabel, self.jewellerLabel, 121, iconeTop, "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_jeweller.tga", _("JEWELLER"));
	self:CreateBestPlayerTooptipByCraft(players, self.jewellerSlotLabel, _("JEWELLER"));
	
	self.metalsmithSlotLabel = Turbine.UI.Control();
	self.metalsmithLabel = Turbine.UI.Control();
	self:SetIconeParameters(self.metalsmithSlotLabel, self.metalsmithLabel, 147, iconeTop, "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_metalsmith.tga", _("METALSMITH"));
	self:CreateBestPlayerTooptipByCraft(players, self.metalsmithSlotLabel, _("METALSMITH"));
	
	self.prospectorSlotLabel = Turbine.UI.Control();
	self.prospectorLabel = Turbine.UI.Control();
	self:SetIconeParameters(self.prospectorSlotLabel, self.prospectorLabel, 173, iconeTop, "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_prospector.tga", _("PROSPECTOR"));
	self:CreateBestPlayerTooptipByCraft(players, self.prospectorSlotLabel, _("PROSPECTOR"));
	
	self.scholarSlotLabel = Turbine.UI.Control();
	self.scholarLabel = Turbine.UI.Control();
	self:SetIconeParameters(self.scholarSlotLabel, self.scholarLabel, 199, iconeTop, "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_scholar.tga", _("SCHOLAR"));
	self:CreateBestPlayerTooptipByCraft(players, self.scholarSlotLabel, _("SCHOLAR"));
	
	self.tailorSlotLabel = Turbine.UI.Control();
	self.tailorLabel = Turbine.UI.Control();
	self:SetIconeParameters(self.tailorSlotLabel, self.tailorLabel, 225, iconeTop, "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_tailor.tga", _("TAILOR"));
	self:CreateBestPlayerTooptipByCraft(players, self.tailorSlotLabel, _("TAILOR"));
	
	self.weaponsmithSlotLabel = Turbine.UI.Control();
	self.weaponsmithLabel = Turbine.UI.Control();
	self:SetIconeParameters(self.weaponsmithSlotLabel, self.weaponsmithLabel, 251, iconeTop, "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_weaponsmith.tga", _("WEAPONSMITH"));
	self:CreateBestPlayerTooptipByCraft(players, self.weaponsmithSlotLabel, _("WEAPONSMITH"));
	
	self.woodworkerSlotLabel = Turbine.UI.Control();
	self.woodworkerLabel = Turbine.UI.Control();
	self:SetIconeParameters(self.woodworkerSlotLabel, self.woodworkerLabel, 277, iconeTop, "WalmPlugins/BandOfFarmers/pictures/actionPicker_icon_craft_woodworker.tga", _("WOODWORKER"));
	self:CreateBestPlayerTooptipByCraft(players, self.woodworkerSlotLabel, _("WOODWORKER"));

	self:UpdateNodeData();		
end

function CraftGlobalNode:SetIconeParameters(slotLabel, profLabel, x, y, icone, profName)
	slotLabel:SetParent( self );
	slotLabel:SetSize( 32, 32 );
	slotLabel:SetPosition( x, y );
	slotLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	slotLabel.profName = profName;
	slotLabel.MouseClick = function()
		bofDlg:HightlightProfession(profName);
	end
	profLabel:SetParent( slotLabel );
	profLabel:SetSize( 26, 24 );
	profLabel:SetPosition( 3, 4 );
	profLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	profLabel:SetBackground( icone );
	profLabel:SetMouseVisible(false);	
end

function CraftGlobalNode:UpdateResponsive(width, height)
	self:SetWidth(width);
	self.rightbox:SetPosition(width-6, 0);
	self.middlebox:SetSize(width-43, 35);
	
	local l=20;
	local w=width-20-l;
	self.cookSlotLabel:SetLeft(l+w/11);
	self.farmerSlotLabel:SetLeft(l+2*w/11);
	self.foresterSlotLabel:SetLeft(l+3*w/11);
	self.jewellerSlotLabel:SetLeft(l+4*w/11);
	self.metalsmithSlotLabel:SetLeft(l+5*w/11);
	self.prospectorSlotLabel:SetLeft(l+6*w/11);
	self.scholarSlotLabel:SetLeft(l+7*w/11);
	self.tailorSlotLabel:SetLeft(l+8*w/11);
	self.weaponsmithSlotLabel:SetLeft(l+9*w/11);
	self.woodworkerSlotLabel:SetLeft(l+10*w/11);
end

function CraftGlobalNode:CreateBestPlayerTooptipByCraft(players, component, craft)
	local topLevel = 0;
	local topPlayer = nil;
	local profId = 0;
	local maxlvl = 13;
	for i=1 , table.getn(players) , 1 do
		local playerData = players[i];
		if(playerData.data~=nil and playerData.data.profession~=nil and table.getn(playerData.data.profession)==3) then
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Test craft de "..playerData.name.." [1]");
			if ((playerData.data.profession[1].name==craft) and (playerData.data.profession[1].level > topLevel)) then
				topLevel = playerData.data.profession[1].level;
				topPlayer = playerData;
				profId = 1;
			end

			if(playerData.data.profession[2].name==craft and playerData.data.profession[2].level > topLevel) then
				topLevel = playerData.data.profession[2].level;
				topPlayer = playerData;
				profId = 2;
			end
			if(playerData.data.profession[3].name==craft and playerData.data.profession[3].level > topLevel) then
				topLevel = playerData.data.profession[3].level;
				topPlayer = playerData;
				profId = 3;
			end
		else
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Pas de craft chez "..playerData.name);
		end
	end
	if(topLevel ~=0) then
		local playerProdData = topPlayer.data.profession[profId];
		component.tooltip = GenericTooltip(component);
		component.tooltip:AddLayer(_("BEST")..craft.." :\n"..topPlayer.name, Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.MiddleCenter, Turbine.UI.Lotro.Font.TrajanProBold22, Turbine.UI.FontStyle.Outline);
		
		component.tooltip:AddLayer( _("LEVEL"), Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);	
		local str = "    "..self:GetCraftLevelById(playerProdData.level).."  ("..playerProdData.level.."/"..maxlvl..")";
		component.tooltip:AddLayer(str, Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
		if (playerProdData.levelXP ~= "0/0") then
			component.tooltip:AddLayer("    ".._("MISSINGXP")..playerProdData.levelXP.."\n", Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
		end
		
		component.tooltip:AddLayer( _("MASTERYLEVEL"), Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
		str = "    "..self:GetCraftLevelById(playerProdData.mastery).."  ("..playerProdData.level.."/"..maxlvl..")";
		component.tooltip:AddLayer(str,  Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
		if(playerProdData.masteryXP ~= "0/0") then
			component.tooltip:AddLayer("    ".._("MISSINGXP")..playerProdData.masteryXP, Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
		end		
	else
		component.tooltip = GenericTooltip(component);
		component.tooltip:AddLayer(craft, Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.MiddleCenter, Turbine.UI.Lotro.Font.TrajanProBold22, Turbine.UI.FontStyle.Outline);
		component.tooltip:AddLayer(_("NOPROFESSION"), Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
	end
end

function CraftGlobalNode:HightlightProfession(name)
	self:HightlightProfession2(self.cookSlotLabel, name);
	self:HightlightProfession2(self.farmerSlotLabel, name);
	self:HightlightProfession2(self.foresterSlotLabel, name);
	self:HightlightProfession2(self.jewellerSlotLabel, name);
	self:HightlightProfession2(self.metalsmithSlotLabel, name);
	self:HightlightProfession2(self.prospectorSlotLabel, name);
	self:HightlightProfession2(self.scholarSlotLabel, name);
	self:HightlightProfession2(self.tailorSlotLabel, name);
	self:HightlightProfession2(self.weaponsmithSlotLabel, name);
	self:HightlightProfession2(self.woodworkerSlotLabel, name);
end

function CraftGlobalNode:HightlightProfession2(component, name)
	if(component.profName==name) then
		component:SetBackground( "WalmPlugins/BandOfFarmers/pictures/overlay_OK.tga" );
	else
		component:SetBackground( nil );
	end	
end

function CraftGlobalNode:GetPlayer()
	return self.player;
end

function CraftGlobalNode:UpdateNodeData(p)
	if p~= nil and p.name == self.player.name  then
		self.player = p;
		-- TODO
	end
end

function CraftGlobalNode:GetCraftLevelById(level)
	if(level==1) then	return _("LEVEL1");
	elseif (level==2) then return _("LEVEL2");
	elseif (level==3) then return _("LEVEL3");
	elseif (level==4) then return _("LEVEL4");
	elseif (level==5) then return _("LEVEL5");
	elseif (level==6) then return _("LEVEL6");
	elseif (level==7) then return _("LEVEL7");
	elseif (level==8) then return _("LEVEL8");
	elseif (level==9) then return _("LEVEL9");
	elseif (level==10) then return _("LEVEL10");
	elseif (level==11) then return _("LEVEL11");
	elseif (level==12) then return _("LEVEL12");
	elseif (level==13) then return _("LEVEL13");
	elseif (level==0) then return _("LEVEL0");
	else return _("LEVEL?");
	end
end

function CraftGlobalNode:GetIconeByCraftName(craft, gold)
	if(craft==_("TAILOR") or craft==_("TAILOR", 1)) then
		if(gold==true) then return "actionPicker_icon_craft_tailor_gold.tga"; end
		return "actionPicker_icon_craft_tailor.tga";
	elseif(craft==_("COOKER") or craft==_("COOKER", 1)) then
		if(gold==true) then return "actionPicker_icon_cook_gold.tga"; end
		return "actionPicker_icon_cook.tga";
	elseif(craft==_("FARMER") or craft==_("FARMER", 1)) then
		if(gold==true) then return "actionPicker_icon_craft_farmer_gold.tga"; end
		return "actionPicker_icon_craft_farmer.tga";
	elseif(craft==_("FORESTER") or craft==_("FORESTER", 1)) then
		if(gold==true) then return "actionPicker_icon_craft_forester_gold.tga"; end
		return "actionPicker_icon_craft_forester.tga";
	elseif(craft==_("PROSPECTOR") or craft==_("PROSPECTOR", 1)) then
		if(gold==true) then return "actionPicker_icon_craft_prospector_gold.tga"; end
		return "actionPicker_icon_craft_prospector.tga";
	elseif(craft==_("METALSMITH") or craft==_("METALSMITH", 1)) then
		if(gold==true) then return "actionPicker_icon_craft_metalsmith_gold.tga"; end
		return "actionPicker_icon_craft_metalsmith.tga";
	elseif(craft==_("SCHOLAR") or craft==_("SCHOLAR", 1)) then
		if(gold==true) then return "actionPicker_icon_craft_scholar_gold.tga"; end
		return "actionPicker_icon_craft_scholar.tga";
	elseif(craft==_("WEAPONSMITH") or craft==_("WEAPONSMITH", 1)) then
		if(gold==true) then return "actionPicker_icon_craft_weaponsmith_gold.tga"; end
		return "actionPicker_icon_craft_weaponsmith.tga";
	elseif(craft==_("WOODWORKER") or craft==_("WOODWORKER", 1)) then
		if(gold==true) then return "actionPicker_icon_craft_woodworker_gold.tga"; end
		return "actionPicker_icon_craft_woodworker.tga";
	else
		if(gold==true) then return "actionPicker_icon_craft_jeweller_gold.tga"; end
		return "actionPicker_icon_craft_jeweller.tga";
	end
end