-- Turbine Imports..
--import "Turbine";
import "Turbine.Gameplay";
--import "Turbine.UI";
--import "Turbine.UI.Lotro";

import "WalmPlugins.BandOfFarmers.Translate";
import "WalmPlugins.BandOfFarmers.Turbine";
import "WalmPlugins.BandOfFarmers.UTF";
import "WalmPlugins.BandOfFarmers.BandOfFarmers";
import "WalmPlugins.BandOfFarmers.QuickLauncher";
import "WalmPlugins.BandOfFarmers.Saving";

RtmCommand = Turbine.ShellCommand();

function IndexOf(t, val)
    for k,v in ipairs(t) do 
        if v == val then return k end
    end
end

function _TEST(index, word)
	for k, value in pairs(STRINGS[index]) do
		if(value==word) then return true; end
	end
	return false;
end

function _T(strList)
	if(strList==nil or type(strList)~="table") then return ""; end
	if(strList[lang]~=nil) then return strList[lang]; end
	if(strList[2]~=nil) then return strList[2]; end
	return "";
end

function InitTranslation()
	lang = 2;
	if Turbine.Shell.IsCommand("hilfe") then
		lang = 3;
	elseif Turbine.Shell.IsCommand("aide") then
		lang = 1;
	end
end

function _(index, l)
	local p = l or lang or 1;
	if(index==nil) then Turbine.Shell.WriteLine(ToUTF8("<rgb=#FF5CCD>BandOfFarmers: Translation error : index=NIHIL</rgb>")); return ""; end
	if(STRINGS[index]==nil) then 
		Turbine.Shell.WriteLine(ToUTF8("<rgb=#FF5CCD>BandOfFarmers: Missing translation : "..index.."</rgb>")); return ""; end
	return STRINGS[index][p];
end

function TRAD(fr, en, de)
	if(lang==1) then
		return fr;
	elseif(lang==3 and de~=nil) then
		return de;
	else
		return en;
	end
end

function RtmCommand:Execute( command, arguments )
	if ( arguments == "?" or arguments == "help" or arguments == "man") then
		Turbine.Shell.WriteLine(RtmCommand:GetHelp());
	elseif ( arguments == "show" ) then		
		OpenPane();	
	end
end

function RtmCommand:GetHelp()
	return "BandOfFarmers\n".._("HELP1").._("COMMANDS")..
			"\n/bof show => ".._("COMSHOW")..
			"\n/bof options => ".._("COMOPTIONS").."\n";
end

function RtmCommand:GetShortHelp()
	return "TODO.";
end

function OpenPane()
	if(bofDlg ~= nil) then
		bofDlg:SetVisible(true);
	end
end

function Savesettings()
	function SavesettingsConfirmation(sender, args)
		Turbine.Shell.WriteLine(ToUTF8("<rgb=#FF5CCD>BandOfFarmers: ".._("SETTINGS_SAVED").."</rgb>"));
	end
	DataSave(Turbine.DataScope.Account, "BandOfFarmers_preferences", settings);
	--if(quickLauncher) then quickLauncher:Applysettings(); end;
end

function Loadsettings()	
	local tmpsettings = DataLoad(Turbine.DataScope.Account, "BandOfFarmers_preferences");
	if(tmpsettings ~= nil) then
		settings = tmpsettings;		
	else
		Reinitsettings();
	end
	if(quickLauncher) then quickLauncher:Applysettings(); end;
end

function Reinitsettings()
	settings = {};
	local width, height = Turbine.UI.Display.GetSize();		
	local width2, height2;
	width2 = width/2 - 300/2;
	height2 = height/3 - 180/2;
	settings.main_x = width2;
	settings.main_y = height2;
	function ptr(sender, args)
		--
	end
	local tmpsettings = DataLoad(Turbine.DataScope.Account, "BandOfFarmers_preferences", ptr);
	if(tmpsettings ~= nil) then
		settings.quicklaunch_x = tmpsettings.quicklaunch_x-40;
		settings.quicklaunch_y = tmpsettings.quicklaunch_y;			
	else
		settings.quicklaunch_x = width-300;
		settings.quicklaunch_y = 20;	
	end
	settings.defaultOpacity = 60;
	settings.canMoveQuickLauncher = false;
	settings.useQuickLauncher = true;
	settings.autoShowOnLaunch = false;
	settings.animateQuickLauncher = true;
	
	if(quickLauncher) then quickLauncher:Applysettings(); end;
end
InitTranslation();
Loadsettings();

optionsPanel = Turbine.UI.Control();
optionsPanel:SetSize(250, 20 );
optionsButton=Turbine.UI.Lotro.Button();
optionsButton:SetSize(250,20);
optionsButton:SetText(_("OPEN_CONFIG"));
optionsButton:SetParent(optionsPanel);
optionsButton.MouseClick=function(sender,args)
	local optionDialog = BuildConfigDialog();
	optionDialog:SetVisible(true);
end
plugin.GetOptionsPanel = function( self )
  	return optionsPanel;
		
end

bofDlg = BandOfFarmers();
quickLauncher = QuickLauncher(bofDlg);
if(settings.useQuickLauncher) then
	quickLauncher:Start();
	quickLauncher:Applysettings();
end
if(settings.autoShowOnLaunch) then
	bofDlg:Start()
end

Turbine.Shell.AddCommand( "bof", RtmCommand );
Turbine.Shell.AddCommand( "BandOfFarmers", RtmCommand );

Turbine.Plugin.Unload = function ()
	if(settings.updateAtLaunchAndUnload) then
		bofDlg:UpdateLocalPlayerData(false);
	end
end

