
PlayerStuffNode = class( Turbine.UI.TreeNode );


function PlayerStuffNode:Constructor(p)
	self.player = p;
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 70 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self:SetBackground("WalmPlugins/BandOfFarmers/background_blue_large.tga");
	
	
	self.playerNameLabel = Turbine.UI.Label();
	self.playerNameLabel:SetParent( self );
	self.playerNameLabel:SetSize( 140, 16 );
	self.playerNameLabel:SetPosition( 42, 3 );
	self.playerNameLabel:SetZOrder(100);
	self.playerNameLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.playerNameLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.playerNameLabel:SetMouseVisible( false );
	--self.playerNameLabel:SetBackColor(Turbine.UI.Color( 0, 0, 1 ));
	if(self.player.data==nil or self.player.data.level == nil) then
		self.playerNameLabel:SetText(self.player.name);
		self.playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	else
		self.playerNameLabel:SetText("["..self.player.data.level.."] "..self.player.name);
	end
	
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetSize( 20, 20 );
	self.classLabel:SetPosition( 9, 7 );
	if(self.player.data==nil) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga");
		self.classLabel:SetPosition( 6, 5 );
		self.classLabel:SetSize( 26, 24 );
	elseif(self.player.data.playerClass == 172) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_champion_20.tga");
	elseif(self.player.data.playerClass == 214) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_beorning_20.tga");
	elseif(self.player.data.playerClass == 40) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_burglar_20.tga");
	elseif(self.player.data.playerClass == 23) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_guardian_20.tga");
	elseif(self.player.data.playerClass == 194) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_warden_20.tga");
	elseif(self.player.data.playerClass == 193) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_runekeeper_20.tga");
	elseif(self.player.data.playerClass == 185) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_loremaster_20.tga");
	elseif(self.player.data.playerClass == 162) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_hunter_20.tga");
	elseif(self.player.data.playerClass == 31) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_minstrel_20.tga");
	elseif(self.player.data.playerClass == 24) then
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_captain_20.tga");
	elseif(self.player.data.playerClass == 215) then
		self.classLabel:SetBackground(  = "WalmPlugins/BandOfFarmers/pictures/fellowship_brawler_20.tga");
	else
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga");
		self.classLabel:SetPosition( 6, 5 );
		self.classLabel:SetSize( 26, 24 );
	end
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.classLabel:SetMouseVisible( false );

	local iconeTop = 9;
	local itemControl = Turbine.UI.Lotro.ItemControl();
	itemControl:SetSize(38, 38);
	itemControl:SetPosition(40, 22);
	itemControl:SetParent( self );
	itemControl:SetBackColor(Turbine.UI.Color( 1, 1, 0.5 ));
	itemControl:SetAllowDrop(false);
	
	
	local player = Turbine.Gameplay.LocalPlayer:GetInstance();
	local item = player:GetEquipment():GetItem(1);
	
	
	--itemControl:SetItem(p.stuff[1]);
	self:UpdateNodeData();		
end

function PlayerStuffNode:UpdateResponsive(width, height)

end

function PlayerStuffNode:GetPlayer()
	return self.player;
end

function PlayerStuffNode:UpdateNodeData(p)
	if p~= nil and p.name == self.player.name  then
		--
	end
end
